"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantSet(ProtocolElement):
    """
    `Variant` and `CallSet` both belong to a `VariantSet`. `VariantSet`
    belongs to a `Dataset`. The variant set is equivalent to a VCF
    file.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "datasetId",
        "id",
        "referenceSetId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_7 import reports as reports_6_9_0

        return {
            "metadata": reports_6_9_0.VariantSetMetadata,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_7 import reports as reports_6_9_0

        return {
            "org.gel.models.report.avro.VariantSetMetadata": reports_6_9_0.VariantSetMetadata,
            "org.gel.models.report.avro.VariantSet": reports_6_9_0.VariantSet,
        }

    __slots__ = [
        "datasetId",
        "id",
        "referenceSetId",
        "metadata",
    ]

    def __init__(
        self,
        datasetId,
        id,
        referenceSetId,
        metadata=list,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_9_0.VariantSet model.

        :param datasetId:
            The ID of the dataset this variant set belongs to.
        :type datasetId: str
        :param id:
            The variant set ID.
        :type id: str
        :param referenceSetId:
            The reference set the variants in this variant set are using.
        :type referenceSetId: str
        :param metadata:
            The metadata associated with this variant set. This is equivalent to
            the VCF header information not already presented in first
            class fields.
        :type metadata: list[VariantSetMetadata]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.9.0"
